From bb9a4c1161c3ee9ced361af2c0d772dc76e5b3f2 Mon Sep 17 00:00:00 2001
From: Tomas Janousek <tomi@nomi.cz>
Date: Thu, 24 May 2007 00:40:44 +0200
Subject: [PATCH] Fix focus issue with fullscreen windows and workspace switching

The check in FluxboxWindow::focus() whether the current focused window is
fullscreen should compare workspace numbers as well. Otherwise we just don't
focus anything when switching from workspace with a fullscreen window to
another one and the focus slips somewhere (which fluxbox ignores).

Signed-off-by: Tomas Janousek <tomi@nomi.cz>
---
 src/Window.cc |    3 ++-
 1 files changed, 2 insertions(+), 1 deletions(-)

diff --git a/src/Window.cc b/src/Window.cc
index b9186c8..4ed6ad0 100644
--- a/src/Window.cc
+++ b/src/Window.cc
@@ -1411,7 +1411,8 @@ bool FluxboxWindow::focus() {
     FluxboxWindow *cur = FocusControl::focusedFbWindow();
     WinClient *client = FocusControl::focusedWindow();
     if (cur && client && cur != this && cur->isFullscreen() &&
-        getRootTransientFor(m_client) != getRootTransientFor(client))
+        getRootTransientFor(m_client) != getRootTransientFor(client) &&
+        (cur->workspaceNumber() == screen().currentWorkspaceID() || cur->isStuck()))
         return false;
 
     if (isIconic()) {
-- 
1.5.1.4

